.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\gdi32.lib

include cocomac.mac
include TreeView.mac

$invoke MACRO vars:VARARG
	invoke vars
	EXITM <eax>
ENDM

m2m MACRO Des:REQ, Sor:REQ
	push Sor
	pop  Des		
ENDM

date MACRO
	% FORC chr, @Date
		db "&chr"
	ENDM
ENDM

S MACRO sText
	local lbl
	.data
	IFNB <sText>
		lbl db sText, 0
	ELSE
		lbl db 0
	ENDIF
	.code
	EXITM <offset lbl>
ENDM

$LOWORD MACRO dwVar:REQ
	IF $IsImm(dwVar)
		EXITM <dwVar AND 0FFFFh>
	ELSE
		IFDIFI <dwVar>, <eax>	;; don't move eax onto itself
			mov eax, dwVar
		ENDIF
		and eax, 0FFFFh
		EXITM <eax>
	ENDIF
ENDM

$HIWORD MACRO dwVar:REQ
	IF $IsImm(dwVar)
		EXITM <dwVar SHR 16>
	ELSE
		IFDIFI <dwVar>, <eax>	;; don't move eax onto itself
			mov eax, dwVar
		ENDIF
		shr eax, 16
		EXITM <eax>
	ENDIF
ENDM

.const
	IDD_CHILD	equ 2000
	IDD_DIALOG	equ 1000

	IDM_MENU	equ 10000
	IDM_FILE_EXIT	equ 10001
	IDM_HELP_ABOUT	equ 10101
	
	IDC_TREEVIEW	equ 2001
	IDI_ICON	equ 200
	IDI_NRM_BITMAP	equ 201
	IDI_CHK_BITMAP	equ 202

	NUM_NRM_IMAGES	equ 6
	NUM_CHK_IMAGES	equ 2

	szTreeViewClassName	db "SysTreeView32", 0
	ClassName		db 'DLGCLASS',0
	AppName			db 'Dialog as main',0
	AboutMsg		db 'MASM32 RadASM Dialog as main',13,10,'Copyright  MASM32 2001',0
.data?
	CommandLine	dd		?
	hWnd		dd		?
	hInstance	HINSTANCE	?
	g_hwndTreeView	HWND		?
	g_hImageListNrm	HANDLE		?
	g_hImageListChk	HANDLE		?
.code

FillTreeView proc uses esi ebx
	local tvins:TV_INSERTSTRUCT
	local hRoot:HANDLE
	local hKernel:HANDLE
	local hShare:HANDLE
	local hOwn:HANDLE
	local InterActive:HANDLE
	local hAdapter:HANDLE

	lea esi, tvins
	assume esi:ptr TV_INSERTSTRUCT
	mov [esi].hParent, NULL
	mov [esi].hInsertAfter, TVI_ROOT
	mov [esi].item._mask, TVIF_TEXT + TVIF_SELECTEDIMAGE + TVIF_IMAGE
	mov [esi].item.pszText, S("All")
	mov [esi].item.iImage, 0
	mov [esi].item.iSelectedImage, 0 + NUM_NRM_IMAGES
	TreeView_InsertItem g_hwndTreeView, esi

	mov hRoot, eax

	mov [esi].hParent, eax
	mov [esi].hInsertAfter, TVI_LAST
	or [esi].item._mask, TVIF_STATE + TVIS_STATEIMAGEMASK
	
	mov [esi].item.state, (2 SHL 12)					; checked
	mov [esi].item.stateMask, TVIS_STATEIMAGEMASK
	mov [esi].item.pszText, S("Kernel-Driver")
	inc [esi].item.iImage
	inc [esi].item.iSelectedImage
	TreeView_InsertItem g_hwndTreeView, esi

	mov hKernel, eax

	mov [esi].item.state, (1 SHL 12)					; unchecked
	mov [esi].item.pszText, S("Share-Process")
	inc [esi].item.iImage
	inc [esi].item.iSelectedImage
	TreeView_InsertItem g_hwndTreeView, esi

	mov hShare, eax

	mov [esi].item.state, (2 SHL 12)					; checked
	mov [esi].item.pszText, S("Own-Process")
	inc [esi].item.iImage
	inc [esi].item.iSelectedImage
	TreeView_InsertItem g_hwndTreeView, esi

	mov hOwn, eax

	mov [esi].item.state, (1 SHL 12)					; unchecked
	mov [esi].item.pszText, S("InterActive-Process")
	inc [esi].item.iImage
	inc [esi].item.iSelectedImage
	TreeView_InsertItem g_hwndTreeView, esi

	mov InterActive, eax

	mov [esi].item.state, (2 SHL 12)					; unchecked
	mov [esi].item.pszText, S("Adapter")
	inc [esi].item.iImage
	inc [esi].item.iSelectedImage
	TreeView_InsertItem g_hwndTreeView, esi

	mov hAdapter, eax

	mov [esi].item.iImage, 6
	mov [esi].item.iSelectedImage, 6 + NUM_NRM_IMAGES

	xor ebx, ebx
	.while ebx < 5
		m2m [esi].hParent, hAdapter[ebx*(sizeof HANDLE)]
		TreeView_GetCheckState g_hwndTreeView, [esi].hParent
		.if eax == 0									; unchecked
			mov [esi].item.state, (1 SHL 12)
		.elseif eax == 1								; checked
			mov [esi].item.state, (2 SHL 12)
		.endif
		mov [esi].item.pszText, S("stopped")
		TreeView_InsertItem g_hwndTreeView, esi

		mov [esi].item.pszText, S("running")
		TreeView_InsertItem g_hwndTreeView, esi

		mov [esi].item.pszText, S("paused")
		TreeView_InsertItem g_hwndTreeView, esi
		
		mov [esi].item.pszText, S("start_pending")
		TreeView_InsertItem g_hwndTreeView, esi

		mov [esi].item.pszText, S("stop_pending")
		TreeView_InsertItem g_hwndTreeView, esi
		
		mov [esi].item.pszText, S("continue_pending")
		TreeView_InsertItem g_hwndTreeView, esi
		
		mov [esi].item.pszText, S("pause_pending")
		TreeView_InsertItem g_hwndTreeView, esi

		inc ebx
	.endw

	TreeView_Expand g_hwndTreeView, hRoot, TVE_EXPAND

	ret

FillTreeView endp

CheckNode proc uses ebx hwndTreeView:HWND, hNode:HANDLE
	local fCheck:UINT

	TreeView_GetCheckState hwndTreeView, hNode
	.if eax == 1									; checked ?
		mov eax, FALSE								; uncheck
	.elseif eax == 0								; unchecked ?
		mov eax, TRUE								; check
	.endif
	mov fCheck, eax
	TreeView_SetCheckState hwndTreeView, hNode, eax

	TreeView_GetChild hwndTreeView, hNode
	.while eax != NULL
		mov ebx, eax
		; Item has children. Check/uncheck them
		TreeView_SetCheckState hwndTreeView, ebx, fCheck
		TreeView_GetNextSibling hwndTreeView, ebx
	.endw

	ret

CheckNode endp

ChildDlgProc proc uses esi hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local tvhti:TV_HITTESTINFO

	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		invoke GetDlgItem, hWin, IDC_TREEVIEW
		mov g_hwndTreeView, eax
		invoke SendMessage,g_hwndTreeView,TVM_SETLINECOLOR,0,0ff00ffh					;	00ffffe0h

		mov g_hImageListNrm, $invoke(ImageList_Create, 16, 16, ILC_COLOR24 + ILC_MASK, NUM_NRM_IMAGES, 0)
		invoke LoadBitmap, hInstance, IDI_NRM_BITMAP
		push eax				; for DeleteObject
		invoke ImageList_AddMasked, g_hImageListNrm, eax, Magenta
		call DeleteObject
		TreeView_SetImageList g_hwndTreeView, g_hImageListNrm, TVSIL_NORMAL

		mov g_hImageListChk, $invoke(ImageList_Create, 16, 16, ILC_COLOR24 + ILC_MASK, NUM_CHK_IMAGES, 0)
		invoke LoadBitmap, hInstance, IDI_CHK_BITMAP
		push eax				; for DeleteObject
		invoke ImageList_AddMasked, g_hImageListChk, eax, Magenta
		call DeleteObject
		TreeView_SetImageList g_hwndTreeView, g_hImageListChk, TVSIL_STATE

		invoke FillTreeView
	.elseif eax == WM_NOTIFY
		mov esi, lParam
		.if  wParam == IDC_TREEVIEW
			mov eax, (NMHDR ptr [esi]).code 
			.if eax == NM_CLICK
				invoke GetMessagePos
				push eax
				mov tvhti.pt.x, $LOWORD(eax)
				pop eax
				mov tvhti.pt.y, $HIWORD(eax)

				invoke ScreenToClient, (NMHDR ptr [esi]).hwndFrom, addr tvhti.pt
				mov eax, tvhti.pt.x

				TreeView_HitTest (NMHDR ptr [esi]).hwndFrom, addr tvhti

				.if tvhti.flags & TVHT_ONITEMSTATEICON		; click over state icon ?
					invoke CheckNode, (NMHDR ptr [esi]).hwndFrom, tvhti.hItem
				.endif

			.elseif eax == TVN_KEYDOWN
            			; let user check/uncheck items with space key
            			mov eax, lParam
            			.if [TV_KEYDOWN ptr [eax]].wVKey == VK_SPACE
            				TreeView_GetSelection (NMHDR ptr [esi]).hwndFrom
					invoke CheckNode, (NMHDR ptr [esi]).hwndFrom, eax
            			.endif
			.endif
		.endif
	.elseif eax==WM_COMMAND

	.elseif eax == WM_SYSCOLORCHANGE
		mov ebx, $invoke(GetSysColor, COLOR_WINDOW)
		invoke ImageList_SetBkColor, g_hImageListNrm, ebx
		TreeView_SetBkColor g_hwndTreeView, ebx
	.elseif eax==WM_DESTROY
		invoke ImageList_Destroy, g_hImageListNrm
		invoke ImageList_Destroy, g_hImageListChk
		invoke PostQuitMessage,NULL
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret

ChildDlgProc endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop	hWnd
		; Set Dialog Icon
		invoke LoadIcon, hInstance, IDI_ICON
		invoke SendMessage, hWin, WM_SETICON, ICON_BIG, eax
	.elseif eax==WM_COMMAND
		mov	eax,wParam
		and	eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.endif
	.elseif eax==WM_SIZE
	
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov	wc.cbSize,sizeof WNDCLASSEX
	mov	wc.style,CS_HREDRAW or CS_VREDRAW
	mov	wc.lpfnWndProc,offset WndProc
	mov	wc.cbClsExtra,NULL
	mov	wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop	wc.hInstance
	mov	wc.hbrBackground,COLOR_BTNFACE+1
	mov	wc.lpszMenuName,IDM_MENU
	mov	wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov	wc.hIcon,eax
	mov	wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov	wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	mov	hWnd, eax
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	
	invoke	CreateDialogParam, hInstance, IDD_CHILD, hWnd, ChildDlgProc, 0
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
		.BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov	eax,msg.wParam
	ret

WinMain endp

start:
	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov    CommandLine,eax
	invoke InitCommonControls
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

end start

